#restore.ps1
#Restores a database with a new name from an existing backup
[System.Reflection.Assembly]::LoadWithPartialName('Microsoft.SqlServer.SMO')  | out-null

$dbname = "AdWorks"
$bckfile = 'C:\MSSQL.2\MSSQL\Backup\AdventureWorks_db_20071227175004.bak'

$s = new-object ('Microsoft.SqlServer.Management.Smo.Server') '.\SQLEXPRESS'

$bdi = new-object ('Microsoft.SqlServer.Management.Smo.BackupDeviceItem') ($bckfile, 'File')
$rs = new-object('Microsoft.SqlServer.Management.Smo.Restore')
$rs.Database = $dbname
$rs.Devices.Add($bdi)
$rsfile = new-object('Microsoft.SqlServer.Management.Smo.RelocateFile')
$rslog = new-object('Microsoft.SqlServer.Management.Smo.RelocateFile')
$rsfile.LogicalFileName = "AdventureWorks_Data"
$rsfile.PhysicalFileName = $s.Information.MasterDBPath + '\'+ $dbname + '_Data.mdf'
$rslog.LogicalFileName = "AdventureWorks_Log"
$rslog.PhysicalFileName = $s.Information.MasterDBLogPath + '\'+ $dbname + '_Log.ldf'
$rs.RelocateFiles.Add($rsfile)
$rs.RelocateFiles.Add($rslog)
$rs.SqlRestore($s)

