#scripting.ps1
#Script all the table objects in the AdventureWorks database

[System.Reflection.Assembly]::LoadWithPartialName("Microsoft.SqlServer.SMO") | out-null

$s = new-object ('Microsoft.SqlServer.Management.Smo.Server') 'SQLTBWS\TONTO'
$db = $s.Databases['AdventureWorks']

$scrp = new-object ('Microsoft.SqlServer.Management.Smo.Scripter') ($s)
$scrp.Options.ScriptDrops = $False
$scrp.Options.WithDependencies = $True
$scrp.Options.FileName = 'c:\PSDBAAdmin\dbscript.sql'
$scrp.Options.IncludeHeaders = $True
$scrp.Options.AppendToFile = $True
$scrp.Options.ToFileOnly = $True
$scrp.Options.ClusteredIndexes = $True
$scrp.Options.DriAll = $True
$scrp.Options.Indexes = $True

$scrp.Script($db.Tables)
