#tcpport.ps1
#Evaluates the SQL Server instances on a Windows server and returns the TCP port number used by each instance
[System.Reflection.Assembly]::LoadWithPartialName("Microsoft.SqlServer.SMO")  | Out-Null                          
$m = New-Object ('Microsoft.SqlServer.Management.Smo.WMI.ManagedComputer') '.'                              
$m.ServerInstances | ForEach-Object { $m.Name + '\' + $_.Name + ', ' + 
		$m.ServerInstances[$_.Name].ServerProtocols['Tcp'].IPAddresses['IPAll'].IPAddressProperties['TcpDynamicPorts'].Value
	}
	
